public _iprint
public _bprint
public _getstr
public _atoi
public _IsSegment

_text segment  'code'
    assume  cs:_text,ds:_data

_IsSegment proc near    ;returns register no in ax
    push bp
    push si
    ;retrieving parameter
    mov bp, sp
    mov si, [bp+6]
    skiploop: ; Skipping blanks
        cmp byte ptr [si], ' '
        jne afterskipping
        inc si
        jmp skiploop
    afterskipping:
        cmp byte ptr [si + 1], 's'
        je firstchar
        cmp byte ptr [si + 1], 'S'
        je firstchar
        jmp NotRegister

    firstchar:
        cmp byte ptr [si], 'D'
        je DSReg
        cmp byte ptr [si], 'd'
        je DSReg
        cmp byte ptr [si], 'E'
        je ESReg
        cmp byte ptr [si], 'e'
        je ESReg
        cmp byte ptr [si], 'C'
        je CSReg
        cmp byte ptr [si], 'c'
        je CSReg
        cmp byte ptr [si], 's'
        je SSReg
        cmp byte ptr [si], 'S'
        je SSReg
    NotRegister:
        mov ax, 0
        jmp done
    DSReg:
        mov ax, 1
        jmp updatepointer
    ESReg:
        mov ax, 2
        jmp updatepointer
    CSReg:
        mov ax, 3
        jmp updatepointer
    SSReg:
        mov ax, 4
    updatepointer:
        add si, 2
        mov [bp+6], si
    done:
        pop si
        pop bp
        ret
_IsSegment endp

_atoi proc near
        ;returns value in ax
        ;adjusts pointer to string to make it point to the part of string not scanned
    push bx
    push cx
    push dx
    push si
    ;retrieving parameter
    mov bp, sp
    mov si, [bp+10]
    loop1: ; Skipping blanks
        cmp byte ptr [si], ' '
        jne blanksskipped
        inc si
        jmp loop1

    blanksskipped:
    mov cx, 16
    mov ax, 0
    loop2:
        mov bh, 0
        mov bl, [si]
        cmp bl, '0'
        jl endloop2
        cmp bl, '9'
        jle digitfound
        cmp bl, 'A'
        jl endloop2
        cmp bl, 'F'
        jle Hexdigitfound
        cmp bl, 'a'
        jl endloop2
        cmp bl, 'f'
        jle smallHexdigitfound

        jmp endloop2
        smallHexDigitfound:
            sub bl, 32
        Hexdigitfound:
            sub bl, 7
        digitfound:
            sub bx, '0'
            mul cx
            add ax, bx
            inc si
            jmp loop2
    endloop2:
    mov [bp+10], si
    pop si
    pop dx
    pop cx
    pop bx
    ret
_atoi endp


_iprint  proc near ; number in stack
    ;; uses ax, bx, cx, dx, bp, si, di
    push ax
    push bx
    push cx
    push dx
    push bp
    push si
    push di
    push ds

    mov ax, _data
    mov ds, ax
    mov bp, sp
    mov bx, 16
    mov ax, 18[bp]   ;retrieving parameter
    mov si, 3
    mov buffer,   48
    mov buffer+1, 48
    mov buffer+2, 48
    mov buffer+3, 48

loupi:
    mov dx, 0 
    div bx
    add dl, 30h
    cmp dl, 57
    jle noadd
    add dl, 7

    noadd:
    mov buffer[si], dl
    dec si
    cmp ax, 0
    jnz loupi


;;; print string

    mov ah, 09h
    lea dx, buffer
    int 21h

    pop ds
    pop di
    pop si
    pop bp
    pop dx
    pop cx
    pop bx
    pop ax
    ret
_iprint  endp

_bprint proc near
    push ax
    push bx
    push cx
    push dx
    push bp
    push si
    push di
    push ds

    mov ax, _data
    mov ds, ax
    mov bp, sp
    mov bl, 16
    mov ax, 18[bp]   ;retrieving parameter
    mov si, 3
    mov buffer+2, 48
    mov buffer+3, 48

loupb:
    mov ah, 0 
    div bl
    add ah, 30h
    cmp ah, 57
    jle noaddb
    add ah, 7

    noaddb:
    mov buffer[si], ah
    dec si
    cmp al, 0
    jnz loupb

    ;;; print string
    mov ah, 09h
    lea dx, buffer+2
    int 21h

    pop ds
    pop di
    pop si
    pop bp
    pop dx
    pop cx
    pop bx
    pop ax
    ret

_bprint endp

_getstr proc near
    push dx
    mov ah, 0ah
    lea dx, NamePar
    int 21h
    lea ax, ActualLen
    pop dx
    ret
    
_getstr endp



_text ends

_data   segment word public 'data'
    buffer  db 4 dup(0), ' $'   ; _iprint and _bprint use this buffer

    NamePar label byte          ; _getstr uses this structure
        MaxLen      db 20
        ActualLen   db 0
        String      db 20 dup(32), '$'
_data ends

zndseg  segment
    ;dummy segment
zndseg ends

end

